/* MouseWheek Dll ********************************************************
 *
 * Version:			2.7.0.0.0
 * FileName:		mousewheel.dll
 * Date Created:	7/08/2003
 *
 * Author:			Soul_Eater
 * Comments:
 *		Allows user to control the Mouse Wheel
 *
 *******************************************************************/
//thanks to Narusegawa-Naru for some code in this shizzle
#pragma check_stack(off)
#pragma comment(linker,"/OPT:NOWIN98")
#include <windows.h>
#include <winuser.h>
#include <zmouse.h>
#define STAYLOADED
#define USE_EVENTS
#define WM_MCOMMAND ((WM_USER) + 200) 	
#ifndef SPI_GETWHEELSCROLLLINES
#define SPI_GETWHEELSCROLLLINES   104
#endif


HWND mwnd,mIRCWND;
char end[300];
int count = 0;
int Search(HWND hwnd);
WNDPROC OldProc[999];
UINT uMSH_MOUSEWHEEL = 0; 
HINSTANCE OurSelf;
BOOL StayLoaded = FALSE;
LPSTR			      mData;
HANDLE              hFileMap;
WNDPROC SubclassWindow(HWND hwnd,WNDPROC WndProc);
LRESULT CALLBACK  MouseWheelProc(HWND,UINT,WPARAM,LPARAM);
void				DllMainLoadDll(void);
void				DllMainUnloadDll(void);
BOOL DoCommand(char *command);
typedef struct tagPROCSTRUCT{; 
	int index; 	
	HWND procwin;
	WNDPROC procold;
	HWND procz;
} PROCSTRUCT,*LPPROCSTRUCT;
PROCSTRUCT AllProcs[500];
BOOL DoCommand(char *command)
{
	wsprintf(mData,"/%s",command);
	return SendMessage(mIRCWND,WM_MCOMMAND,1,0);
}

LRESULT CALLBACK  MouseWheelProc(HWND hwnd,UINT msg,WPARAM wp,LPARAM lp)
{
	 static int nZoom = 0;

     switch(msg)
    
   {
      case WM_MOUSEWHEEL:
		  ((short) HIWORD(wp)< 0) ? nZoom-- : nZoom++;

		  if ((int)wp > 0) {   
			   int ok = Search(hwnd);
	   wsprintf(end,"%s %d %s %d","//.signal -n mousewheel ",(int)AllProcs[ok].procz," up ",(int)nZoom);
        DoCommand(end);
		  }
		  if ((int)wp < 0) {
			   int ok = Search(hwnd);
	   wsprintf(end,"%s %d %s %d","//.signal -n mousewheel ",(int)AllProcs[ok].procz," down ",(int)nZoom);
        DoCommand(end);
		  }
         break;
	  case WM_DESTROY:
          SubclassWindow(hwnd,NULL);
		  PostMessage(hwnd,WM_DESTROY,0,0);
		  return 0;
        default: 
            if(msg == uMSH_MOUSEWHEEL ) {
				((short) HIWORD(wp)< 0) ? nZoom-- : nZoom++;

	  if ((int)wp > 0) {
		    int ok2 = Search(hwnd);
	   wsprintf(end,"%s %d %s %d","//.signal -n mousewheel ",(int)AllProcs[ok2].procz," up ",(int)nZoom);
        DoCommand(end);
		  }
		  if ((int)wp < 0) {
			    int ok2 = Search(hwnd);;
	   wsprintf(end,"%s %d %s %d","//.signal -n mousewheel ",(int)AllProcs[ok2].procz," down ",(int)nZoom);
        DoCommand(end);
		  }
                break;
			}
			int blah = Search(hwnd);
           return CallWindowProc(AllProcs[blah].procold,hwnd,msg,wp,lp);
	 }
    return 0L;

}

WNDPROC SubclassWindow(HWND hwnd,WNDPROC WndProc)
{
	return (WNDPROC)SetWindowLong(hwnd,GWL_WNDPROC,(LONG)WndProc);
}

int __stdcall Mw(HWND mWnd, HWND aWnd, char *data, char *parms, BOOL show, 
					   BOOL nopause)
{
	
   HWND window = (HWND)atoi(data);
   if (!IsWindow(window)) { 
	   lstrcpy(data,"MW_ERR Window does not exist"); 
	   return 3; 
   }
   HWND mwhwnd = GetDlgItem(window,0x8096);
  uMSH_MOUSEWHEEL = RegisterWindowMessage(MSH_MOUSEWHEEL); 
	AllProcs[count].procold = SubclassWindow(mwhwnd,MouseWheelProc);
	AllProcs[count].procwin = mwhwnd;
	AllProcs[count].procz = window;
		 count++;
   lstrcpy(data,"MW_OK Window set");
   return 3;
}
int __stdcall MwDlg(HWND mWnd, HWND aWnd, char *data, char *parms, BOOL show, 
					   BOOL nopause)
{
	
   HWND window = (HWND)atoi(data);
   if (!IsWindow(window)) { 
	   lstrcpy(data,"MW_ERR Dialog does not exist"); 
	   return 3; 
   }
   uMSH_MOUSEWHEEL = RegisterWindowMessage(MSH_MOUSEWHEEL); 
	AllProcs[count].procold = SubclassWindow(window,MouseWheelProc);
	AllProcs[count].procwin = window;
    AllProcs[count].procz = window;
		 count++;
   lstrcpy(data,"MW_OK Dialog set");
   return 3;
}

//# of scroll lines in the window
int __stdcall ScrollLines(HWND mWnd, HWND aWnd, char *data, char *parms, BOOL show, 
					   BOOL nopause)
{

   HWND hdlMsWheel;
   UINT ucNumLines=3;  
   OSVERSIONINFO osversion;
   UINT uiMsh_MsgScrollLines;
   

   memset(&osversion, 0, sizeof(osversion));
   osversion.dwOSVersionInfoSize =sizeof(osversion);
   GetVersionEx(&osversion);

   if ((osversion.dwPlatformId ==
                        VER_PLATFORM_WIN32_WINDOWS) ||
       ( (osversion.dwPlatformId ==
                      VER_PLATFORM_WIN32_NT) && 
         (osversion.dwMajorVersion < 4) )   )
   {
        hdlMsWheel = (HWND)atoi(data);

//	     hdlMsWheel = FindWindow(MSH_WHEELMODULE_CLASS, 
//                                MSH_WHEELMODULE_TITLE);


        if (hdlMsWheel)
        {
           uiMsh_MsgScrollLines = RegisterWindowMessage
                                     (MSH_SCROLL_LINES);
           if (uiMsh_MsgScrollLines)
                ucNumLines = (int)SendMessage(hdlMsWheel,
                                    uiMsh_MsgScrollLines, 
                                                       0, 
                                                       0);
        }
   }
   else if ( (osversion.dwPlatformId ==
                         VER_PLATFORM_WIN32_NT) &&
             (osversion.dwMajorVersion >= 4) )
   {
      SystemParametersInfo(SPI_GETWHEELSCROLLLINES,
                                          0,
                                    &ucNumLines, 0);
   }
   wsprintf(data,"%d",ucNumLines);
   return 3;
}



int MsgBox(char *data)
  {
 int xa = MessageBox (mwnd, data , "MouseWheel DLL" , MB_OK | MB_ICONINFORMATION );
 return 0;
}

int Search(HWND hwnd) {
	 for (int i = 0;i < count;i++)
 if (AllProcs[i].procwin == hwnd) return i;
 return 0;
}


int WINAPI DllInfo(HWND,HWND,char *data,char*,BOOL,BOOL)
{
   MsgBox("MouseWheel DLL v2.7 by Soul_Eater \n2003\nContact Information:\nAIM- SoulEata , Email- souleata@xrs.net");
   return 0;
}


typedef struct
{
	DWORD  mVersion;
	HWND   mHwnd;
	BOOL   mKeep;
} LOADINFO;


void WINAPI LoadDll(LOADINFO *li)
{
	mIRCWND = li->mHwnd;
	hFileMap = CreateFileMapping(INVALID_HANDLE_VALUE,0,PAGE_READWRITE,0,
		0x4000,"mIRC");
	mData = (LPSTR)MapViewOfFile(hFileMap,FILE_MAP_ALL_ACCESS,0,0,0);
	if (!StayLoaded)
		li->mKeep = FALSE;

}

int WINAPI UnloadDll(int timeout)
{
	if (!timeout)
	{
		UnmapViewOfFile(mData);
		CloseHandle(hFileMap);
		return 1;
	}
	return 0;
}

BOOL WINAPI DllMain(HINSTANCE hinst,DWORD reason,LPVOID)
{
	switch(reason)
	{
		case DLL_PROCESS_ATTACH:
#ifdef STAYLOADED
			StayLoaded = TRUE;
#endif
			OurSelf = hinst;
#ifdef CALL_ON_LOAD
			DllMainLoadDll();
#endif
#ifdef NOTIFY_EVENTS
			UseEvents = TRUE;
#endif
			break;

#ifdef CALL_ON_UNLOAD
			DllMainUnloadDll();
#endif
			break;
	}
	return TRUE;
}
